.386
.model flat,stdcall
option casemap:none

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

include windows.inc
include user32.inc
include kernel32.inc

include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib

wordlow MACRO xParam
	mov eax,xParam
	and eax,0FFFFh	
EndM

wordhigh MACRO xParam
	mov eax,xParam
	shr eax,16
EndM

.data
ClassName db "SimpleWinClass",0
szAppName  db "Our First Window",0

szHitTest	db "Hit test success!",0

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?

hRegion dword ?
hRegion2 dword ?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR szAppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	
	local x:DWORD
	local y:DWORD
	
	local hBrush:DWORD
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd, ADDR ps
		mov    hdc,eax
		
		invoke CreateEllipticRgn,20,20,100,100
		mov hRegion,eax		
		invoke CreateSolidBrush,00d0d0dh	
		mov hBrush,eax		
		invoke FrameRgn,hdc,hRegion,hBrush,3,3		
		invoke DeleteObject,hBrush
		
		;**** uncomment next line and hit test fails for hRegion too.
		;invoke DeleteObject,hRegion
				
		invoke CreateEllipticRgn,20,110,100,190
		mov hRegion2,eax
		invoke CreateSolidBrush,0dededeh	
		mov hBrush,eax		
		invoke FrameRgn,hdc,hRegion2,hBrush,3,3
		invoke DeleteObject,hBrush
		invoke DeleteObject,hRegion2
		
		invoke EndPaint,hWnd, ADDR ps
		
	.elseif uMsg == WM_MOUSEMOVE
	
		wordlow lParam
		mov x,eax
		wordhigh lParam
		mov y,eax
		
		invoke PtInRegion,hRegion,x,y
		.if eax != 0			
			invoke MessageBox,hWnd,addr szHitTest,addr szAppName,0			
		.endif
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
end start
